# frozen_string_literal: true

# Books helper
module BooksHelper
  def cart_summary
    number_to_currency(@books.map(&:price).reduce(:+))
  end

  def can_book_be_added?(book)
    logged_in? && book.quantity.positive? && !current_user.books.exists?(book.id)
  end
end
