# frozen_string_literal: true

# Application record
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
  def update(*args)
    result = super(*args)
    AuditRecord.create(model: self.class, action: 'update', params: to_json)
    result
  end

  def save(*args)
    result = super(*args)
    AuditRecord.create(model: self.class, action: 'save', params: to_json)
    result
  end

  def self.create(*args)
    result = super(*args)
    AuditRecord.create(model: self.class, action: 'create', params: result.to_json)
    result
  end

  def decrement!(*args)
    result = super(*args)
    AuditRecord.create(model: self.class, action: 'decrement!', params: to_json)
    result
  end
end
